Rune Central

The Official Rune Quake Message Board
It is currently Tue Sep 25, 2018 9:10 pm

All times are UTC - 5 hours [ DST ]




Post new topic Reply to topic  [ 6 posts ] 
Author Message
 Post subject: Linux + fmod
PostPosted: Tue May 24, 2005 3:26 am 
Offline
User avatar

Joined: Tue Dec 09, 2003 5:49 am
Posts: 27
Location: Poland (Warsaw)
JoeQuake is build and linked against libfmod-3.73.so (fmod library version 3.73). You cannot run JoeQuake without it.

You have 2 options
1. Find on the web unofficial RPM / DEB package (eg. http://rpmfind.net) and install it

2. Download oryginal tar.gz archive from fmod.org (http://fmod.org/ifmoddownload.html), unpack
. . libfmod-xxx.so and put it into:
. . . . a. system libs directory (usual /usr/lib/)
. . . . or
. . . . b. Quake directory
. . . . b2. let Linux know where it can find it. On FC3 it is environment variable LD_LIBRARY_PATH executing:
Code:
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:<path to Quake dir>

. . . . It should be executed (almost) every JoeQuake run, so I think the best solution is adding that line to /etc/profile file.

If it happend that you cannot find fmod ver. 3.73 required by JoeQuake, get newest and create a symbolic link in directory you saved libfmod-xxx.so (/usr/lib or Quake dir):
Code:
ln -s libfmod-x.xx.so libfmod-3.73.so

as an earlier vesion fake (a "wrapper"). I think it should work (at least it works for 3.74).


My own solution:
1. I put libfmod-3.73.so into Quake directory

2. Created quake script quake in /usr/local/bin:
Code:
/mnt/large/games/quake/joequake.glx.sh $*

. . It is just calling main JoeQuake script (joequake.glx.sh) in Quake directory (/mnt/large/games/quake) passing by all arguments

3. Second (main) script in Quake directory (joequake.glx.sh):
Code:
SCRIPT_DIR=$(echo $0 | sed s/\\/[^/]\\+$//)
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$SCRIPT_DIR
cd $SCRIPT_DIR
./joequake.glx -zone 512 -mem 32 -nocdaudio -width 800 -height 600 $*

. . This script is changing (setting proper value) LD_LIBRARY_PATH variable only for Quake session (it does not affect other programs) and setting my default parameters for JoeQuake.

_________________
"Wymiana swin nic nie da, trzeba zabrac koryto" UPR


Top
 Profile  
Reply with quote  
 Post subject:
PostPosted: Tue May 24, 2005 7:08 am 
Offline

Joined: Mon Feb 16, 2004 9:09 am
Posts: 17
Location: Bristol, UK
I still think it's at least as easy to build joequake from source -- that way you can be sure it's not linking against anything that's not on your system "make -f Makefile.linux" should be all it takes (it's something else for software mode, which I need because I haven't gotten hardware acceleration working, but that's not very hard either).


Top
 Profile  
Reply with quote  
 Post subject:
PostPosted: Tue May 24, 2005 8:12 am 
Offline
User avatar

Joined: Tue Dec 09, 2003 5:49 am
Posts: 27
Location: Poland (Warsaw)
mwh wrote:
I still think it's at least as easy to build joequake from source -- that way you can be sure it's not linking against anything that's not on your system "make -f Makefile.linux" should be all it takes

Yes, I agree, but what if it is linking against such thing? You have too know what and where to place it.
BTW. I'm not sure, but I think it is possible to write Makefile which will compile program which will not run (-L.).

I've just checked Makefile from latest sources. Am I wrong or Linux version no longer uses fmod?
Quote:
(it's something else for software mode, which I need because I haven't gotten hardware acceleration working, but that's not very hard either).

Kernel 2.4? "Unusual" graphic card?
I was fighting with FC1 (kernel 2.4) and I found solution on Gentoo forum...

_________________
"Wymiana swin nic nie da, trzeba zabrac koryto" UPR


Top
 Profile  
Reply with quote  
 Post subject:
PostPosted: Tue May 24, 2005 8:20 am 
Offline

Joined: Mon Feb 16, 2004 9:09 am
Posts: 17
Location: Bristol, UK
13Homer wrote:
I've just checked Makefile from latest sources. Am I wrong or Linux version no longer uses fmod?
I have no idea :)
Quote:
Quote:
(it's something else for software mode, which I need because I haven't gotten hardware acceleration working, but that's not very hard either).

Kernel 2.4? "Unusual" graphic card?

Yes to both of those (it's an on board i815 chipset, I think, it's not very good even if I do find the drivers.
Quote:
I was fighting with FC1 (kernel 2.4) and I found solution on Gentoo forum...

Also, complete lack of effort on my part. I just don't care that much.


Top
 Profile  
Reply with quote  
 Post subject:
PostPosted: Wed May 25, 2005 3:51 pm 
Offline
User avatar

Joined: Fri Oct 24, 2003 2:09 pm
Posts: 252
Location: Hungary
Quote:
I've just checked Makefile from latest sources. Am I wrong or Linux version no longer uses fmod?


It does, but it doesn't link into the binary any more. Instead I use dlopen() to get the proper functions for handling mp3 decoding. The only problem is that the name of the fmod package is hard coded in the code, and since the name is changing from time to time, you need to rename never versions to 3.73 or get stuck with the older package... :(
Any ideas of solving this?


Top
 Profile  
Reply with quote  
 Post subject:
PostPosted: Fri May 27, 2005 6:37 am 
Offline
User avatar

Joined: Tue Dec 09, 2003 5:49 am
Posts: 27
Location: Poland (Warsaw)
Lookup. Something like shell completition or which command in multiple directories. He he.

Funny, in ld.so polish manual is one more sentence in NOTES section (in polish called BŁĘDY [ERRORS] (???)): "In current state ld.so has no tools to delete nor search for compatible or newer libraries." ("W stanie obecnym, ld.so nie ma narzędzi do usuwania i szukania kompatybilnych, lub nowszych wersji bibliotek.").

_________________
"Wymiana swin nic nie da, trzeba zabrac koryto" UPR


Top
 Profile  
Reply with quote  
Display posts from previous:  Sort by  
Post new topic Reply to topic  [ 6 posts ] 

All times are UTC - 5 hours [ DST ]


Who is online

Users browsing this forum: No registered users and 4 guests


You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot post attachments in this forum

Search for:
Jump to:  
cron
Powered by phpBB® Forum Software © phpBB Group